!freeram        = $1869|!addr   ;   2 bytes.
!ow_update      = $1F48|!addr   ;   1 byte, cleared only at titlescreen.
!controller     = $18           ;\  should be $16 or $18
                                ;/  https://www.smwcentral.net/?p=memorymap&game=smw&u=0&address=15-18&region[]=ram
!sfx            = $10           ;\  sound to play after correctly inputting the combination. set to 00 for none
!sfx_port       = $1DF9         ;/  https://floating.muncher.se/bot/sound.txt
!original_sb    = 1             ;   set to 1 if youre using the layer 2 status bar (to update the names correctly)

main:
        LDA !freeram
        BEQ +
        DEC
        STA !freeram
        BNE +
        STZ.w !freeram+1
+       LDX.w !freeram+1
        LDA controller_input,x
        CMP #$FF
        BEQ switch
        LDA !controller
        CMP controller_input,x  ;   change to AND for non-exact input (eg. allow other keys to be pressed at the same time)
        BNE return              ;   if you changed ^ to AND, change this to BEQ
        LDA #$10
        STA !freeram
        INC.w !freeram+1
return:
        RTL

switch:
        STZ.w !freeram+1
        STZ !freeram
        INC !ow_update
        if !sfx > $00
                LDA.b #!sfx
                STA.w !sfx_port|!addr
        endif
        LDA $0DB3|!addr
        EOR #$01
        STA $0DB3|!addr
        ASL #2
        TAX
        EOR #$04
        TAY
        LDA $1F17|!addr,y
        STA $1F17|!addr,x
        LDA $1F19|!addr,y
        STA $1F19|!addr,x
        if !original_sb == 1
                LDA $0DB3|!addr
                BNE return
                LDY #$04
                LDX #$08
        -       LDA $008C89,x
                STA $0EF9|!addr,y
                DEX #2
                DEY
                BPL -
        endif
        RTL

controller_input:
        db $10,$20,$10,$20,$FF

